From 7b0e510029beca0b255267470c8f2123520db0d3 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 02 2020 07:51:41 +0000
Subject: [PATCH 1218/2232] Omit namespaces containing no forward declarations


---

diff --git a/gen/src/nested.rs b/gen/src/nested.rs
index 8a1dd6d..0a8816c 100644
--- a/gen/src/nested.rs
+++ b/gen/src/nested.rs
@@ -1,7 +1,6 @@
 use crate::syntax::Api;
 use proc_macro2::Ident;
 use std::collections::HashMap as Map;
-use std::iter::FromIterator;
 
 pub struct NamespaceEntries<'a> {
     direct: Vec<&'a Api>,
@@ -9,9 +8,8 @@ pub struct NamespaceEntries<'a> {
 }
 
 impl<'a> NamespaceEntries<'a> {
-    pub fn new(apis: &'a [Api]) -> Self {
-        let api_refs = Vec::from_iter(apis);
-        sort_by_inner_namespace(api_refs, 0)
+    pub fn new(apis: Vec<&'a Api>) -> Self {
+        sort_by_inner_namespace(apis, 0)
     }
 
     pub fn direct_content(&self) -> &[&'a Api] {
@@ -56,6 +54,7 @@ mod tests {
     use crate::syntax::namespace::Namespace;
     use crate::syntax::{Api, Doc, ExternType, Pair};
     use proc_macro2::{Ident, Span};
+    use std::iter::FromIterator;
     use syn::Token;
 
     #[test]
@@ -73,7 +72,7 @@ mod tests {
             make_api(Some("D"), "J"),
         ];
 
-        let root = NamespaceEntries::new(apis);
+        let root = NamespaceEntries::new(Vec::from_iter(apis));
 
         // ::
         let root_direct = root.direct_content();
diff --git a/gen/src/write.rs b/gen/src/write.rs
index a42d03e..b2046c5 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -18,8 +18,7 @@ pub(super) fn gen(apis: &[Api], types: &Types, opt: &Opt, header: bool) -> Vec<u
     pick_includes_and_builtins(out);
     out.include.extend(&opt.include);
 
-    let apis_by_namespace = NamespaceEntries::new(apis);
-    write_namespace_forward_declarations(out, &apis_by_namespace);
+    write_forward_declarations(out, apis);
     write_data_structures(out, apis);
     write_functions(out, apis);
     write_generic_instantiations(out);
@@ -30,23 +29,34 @@ pub(super) fn gen(apis: &[Api], types: &Types, opt: &Opt, header: bool) -> Vec<u
     out_file.content()
 }
 
-fn write_namespace_forward_declarations(out: &mut OutFile, ns_entries: &NamespaceEntries) {
-    let apis = ns_entries.direct_content();
+fn write_forward_declarations(out: &mut OutFile, apis: &[Api]) {
+    let needs_forward_declaration = |api: &&Api| match api {
+        Api::Struct(_) | Api::CxxType(_) | Api::RustType(_) => true,
+        _ => false,
+    };
 
-    for api in apis {
-        match api {
-            Api::Include(include) => out.include.insert(include),
-            Api::Struct(strct) => write_struct_decl(out, &strct.ident.cxx.ident),
-            Api::CxxType(ety) => write_struct_using(out, &ety.ident.cxx),
-            Api::RustType(ety) => write_struct_decl(out, &ety.ident.cxx.ident),
-            _ => {}
+    let apis_by_namespace =
+        NamespaceEntries::new(apis.iter().filter(needs_forward_declaration).collect());
+
+    write(out, &apis_by_namespace);
+
+    fn write(out: &mut OutFile, ns_entries: &NamespaceEntries) {
+        let apis = ns_entries.direct_content();
+
+        for api in apis {
+            match api {
+                Api::Struct(strct) => write_struct_decl(out, &strct.ident.cxx.ident),
+                Api::CxxType(ety) => write_struct_using(out, &ety.ident.cxx),
+                Api::RustType(ety) => write_struct_decl(out, &ety.ident.cxx.ident),
+                _ => unreachable!(),
+            }
         }
-    }
 
-    for (namespace, nested_ns_entries) in ns_entries.nested_content() {
-        writeln!(out, "namespace {} {{", namespace);
-        write_namespace_forward_declarations(out, nested_ns_entries);
-        writeln!(out, "}} // namespace {}", namespace);
+        for (namespace, nested_ns_entries) in ns_entries.nested_content() {
+            writeln!(out, "namespace {} {{", namespace);
+            write(out, nested_ns_entries);
+            writeln!(out, "}} // namespace {}", namespace);
+        }
     }
 }
 
@@ -65,6 +75,7 @@ fn write_data_structures<'a>(out: &mut OutFile<'a>, apis: &'a [Api]) {
 
     for api in apis {
         match api {
+            Api::Include(include) => out.include.insert(include),
             Api::Struct(strct) => {
                 out.next_section();
                 if !out.types.cxx.contains(&strct.ident.rust) {

